<form method="POST">
    <div class="container-fluid">
        <div class="row">
            <ul class="assigned-difficulties-list">
                <% difficultyLevels.forEach(dl => { %>
                    <li span style="border-color: #<%- dl.rgb_color %>">
                        <%- questions.reduce((sum, curr) => sum + (curr.id_difficulty_level === dl.id), 0) %> 
                        <%- dl.name %> questions
                    </li>
                <% }); %>
            </ul>
            <h2>Exercise questions and difficulties</h2>
            <p>Browse and search questions that are assigned to the exercise (by nodes in exercise definition). 
                Review, set or change assigned question difficulties for the selected exercise adaptivity model.
                Questions in <span style="color: red">red</span> have no assigned difficulty and are therefore not
                used in the question pool for this exercise. Please make sure to assign difficulties to all the
                questions so they can be used.
            </p>
        </div>
        <div class="row edgar-toolbar edgar-sticky">
            <div class="btn-toolbar col-12 pull-right" role="toolbar">
                <div class="btn-group" role="group">
                    <button id="diff-comp-btn" type="button" class="btn btn-light"  data-toggle="modal" data-target="#irtComputationDialog">
                        Start difficulty computation
                    </button>
                    <button id="assign-diffs-btn" type="button" class="btn btn-light">
                        Assign difficulty levels
                    </button>
                    <div class="btn-group" role="group">
                        <button class="btn btn-danger dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                          Delete
                        </button>
                        <div class="dropdown-menu">
                          <button type="button" id="del-diffs-btn" class="dropdown-item">Assigned difficulties</button>
                          <button type="submit" name="delete" value="1" class="dropdown-item">1-param model difficulty computation</button>
                          <button type="submit" name="delete" value="2" class="dropdown-item">2-param model difficulty computation</button>
                        </div>
                      </div>
                      <button type="reset" class="btn btn-primary">Undo changes</button>
                      <button type="submit" class="btn btn-success" name="save" value="save">Save</button>
                </div>
            </div>
        </div>
        <div class="table-responsive" id="questionsTable">
            <table class="table table-sm table-hover edgar">
                <thead>
                    <th>Id/Ver/Act</th>
                    <th>Text</th>
                    <th>Type</th>
                    <th>Answers</th>
                    <th>Correct %</th>
                    <th>Assigned difficulty</th>
                    <th>Computed difficulty</th>
                    <th><abbr title="Item Characteristic Curve">ICC</abbr> <small>(Click for big preview)</small></th>
                </thead>
                <tbody>
                    <% questions.forEach((question, idx) => { %>
                        <tr<% if (!question.id_difficulty_level) { %> class="no-ass-diff"<% } %>>
                            <td class="idVerAct">
                                <%- question.id_ver_act %>
                            </td>
                            <td class="questionText">
                                <%= question.question_text %>
                            </td>
                            <td>
                                <%- question.type_name %>
                            </td>
                            <td class="no_answers">
                                <%- question.no_answers %>
                            </td>
                            <td class="correct_percentage">
                                <%- question.correct_percentage %>
                            </td>
                            <td>
                                <% if (question.id_difficulty_level) { %>
                                    <i class="fa fa-info pull-right" title="Last assigned by <%- question.user_modified_difficulty %> at <%- question.assigned_difficulty_ts_modified %> "></i>
                                <% } %>
                                <div>
                                    <% if (question.id_difficulty_level) { %>
                                        <input type="hidden" name="difficulty[<%- idx %>][id]" value="<%- question.question_difficulty_id %>" />
                                    <% } %>
                                    <input type="hidden" name="difficulty[<%- idx %>][id_question]" value="<%- question.id %>" />
                                    <div class="form-check" data-edgar-color-underline-select>
                                        <input type="radio" class="form-check-input" id="difficulty_<%- idx %>_none" 
                                            name="difficulty[<%- idx %>][id_difficulty_level]" value=""
                                            <% if (!question.id_difficulty_level) { %>checked<% } %>>
                                        <label class="form-label" for="difficulty_<%- idx %>_none" style="border-color: #666;">
                                            None
                                        </label>
                                    </div>
                                    <% difficultyLevels.forEach(option => { %>
                                        <div class="form-check" data-edgar-color-underline-select>
                                            <input type="radio" class="form-check-input" id="difficulty_<%- idx %>_<%- option.id %>"
                                                name="difficulty[<%- idx %>][id_difficulty_level]" value="<%- option.id %>"
                                                <% if (question.id_difficulty_level == option.id) { %>checked<% } %>>
                                            <label class="form-check-label" for="difficulty_<%- idx %>_<%- option.id %>" 
                                                style="border-color: #<%- option.rgb_color %>">
                                                <%- option.name %>
                                            </label>
                                        </div>
                                    <% }); %>
                                </div>
                                <div class="assign-diffs-stat"></div>
                            </td>
                            <td class="IccParams">
                                <% if (question.difficulty_1) { %>
                                    <b class="rasch">1-parameter (Rasch) model</b><br/>
                                    <abbr title="Difficulty">b</abbr> <b><%- question.difficulty_1 %></b><br/>
                                    <% if (question.difficulty_std_err_1) { %>
                                        (std.err. <span class="diff-std-err-1 text-<%- 
                                            question.difficulty_std_err_1 < 3 ? 'success' : 'danger' %>"><%- question.difficulty_std_err_1 %></span>)<br/>
                                    <% } %>
                                <% } %>
                                <% if (question.difficulty_2) { %>
                                    <b class="lord">2-parameter (Lord) model</b><br/>
                                    <abbr title="Difficulty">b</abbr> <b><%- question.difficulty_2 %></b><br/>
                                    <% if (question.difficulty_std_err_2) { %>
                                        (std.err. <span class="diff-std-err-2 text-<%- 
                                            question.difficulty_std_err_2 < 3 ? 'success' : 'danger' %>"><%- question.difficulty_std_err_2 %></span>)<br/>
                                    <% } %>
                                    <abbr title="Discriminating power">a</abbr> 
                                    <b class="text-<%- question.discriminating_power_2 < 0 ? 'danger' : 'success' %>">
                                        <%- question.discriminating_power_2 %>
                                    </b><br />
                                    <% if (question.discriminating_power_std_err_2) { %>
                                        (std.err. <span class="text-<%- 
                                        question.discriminating_power_std_err_2 < 3 ? 'success' : 'danger' %>"><%- question.discriminating_power_std_err_2 %>)</span>
                                    <% } %>
                                <% } %>
                            </td>
                            <td width="200" class="questionIcc" id="questionIcc-<%- idx %>" data-idx="<%- idx %>" 
                                onClick="bigPlot(<% if (question.difficulty_1) { %><%- question.difficulty_1 %>,<% } 
                                if (question.difficulty_2) {%><%- question.difficulty_2 %>, <%- question.discriminating_power_2 %><% } %>)"
                                data-1-b="<%- question.difficulty_1 %>" data-2-b="<%- question.difficulty_2 %>" data-2-a="<%- question.discriminating_power_2 %>">
                            </td>
                        </tr>
                    <% }); %>
                </tbody>
            </table>
        </div>
    </div>
</form>


<div class="modal fade form" id="irtComputationDialog" tabindex="-1" role="dialog">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                <h5 class="modal-title">Question difficulty computation - settings</h5>
            </div>
            <div class="modal-body">
                <p>The question difficulties shall be computed using the Item Response Theory.</p>

                <p>Number of Item Characteristic Curve model parameters</p>
                <div class="form-check">
                    <label class="form-check-label">
                        <input class="form-check-input" type="radio" name="param_model" id="no_model_params_1"> 1-parameter (Rasch) model - difficulty
                    </label>
                    <p class="text-muted">Produces parameter with lower standard error.</p>
                </div>
                <div class="form-check">
                    <label class="form-check-label">
                        <input class="form-check-input" type="radio" name="param_model" id="no_model_params_2" checked> 2-parameter (Lord) model - difficulty + discriminating power
                    </label>
                    <p class="text-muted">May produce parameters with higher standard errors. May not produce any solution.</p>
                </div>

                <div class="form-inline">
                <label class="form-check-label mx-sm-8">Skip questions with less than
                    <select class="form-control mx-xs-4" id="irt_min_answers_threshold">
                        <% for (let i = 1; i < 10; ++i) { %>
                            <option><%- i %></option>
                        <% } %>
                    </select>
                    answers</label>
                </div>
                <p class="text-muted">Skipping questions with only few answers can reduce the error rate in parameter calculation.</p>

                <p class="text-sm">Warning: This process creates a heavy load on the server and can take some time!</p>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-primary" id="start-diff-comp-btn">Start</button>
                <button type="button" class="btn btn-light" data-dismiss="modal">Cancel</button>
            </div>
        </div>
    </div>
</div>
<div class="modal fade form" id="irtComputationProgress" tabindex="-1" role="dialog">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                <h5 class="modal-title">Question difficulty computation - progress</h5>
            </div>
            <div class="modal-body">
                <p>The computation is in progress... The results will be shown upon computation completion.</p>
            </div>
        </div>
    </div>
</div>
<div class="modal fade form" id="irtComputationResults" tabindex="-1" role="dialog">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                <h5 class="modal-title">Question difficulty computation results</h5>
            </div>
            <div class="modal-body" style="overflow: scroll; max-height: 600px" id="irtComputationResultsContainer">
            </div>
            <div class="modal-footer">
                <a href="javascript:window.location.reload(true)" class="btn btn-primary">Refresh page</a>
            </div>
        </div>
    </div>
</div>
<div class="modal fade assign-difficulties" id="assignDifficultiesDialog" tabindex="-1" role="dialog">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                <h5 class="modal-title">Assign difficulty levels based on computed difficulties</h5>
            </div>
            <div class="modal-body">
                <p>First, the computed difficulties interval(s) will be calculated based on the number of difficulty levels (<%- difficultyLevels.length %>) 
                    for the adaptivity model chosen for this exercise.
                    Second, the assigned difficulties will be mapped to match these intervals in the way you choose.
                    You will see the preview in the table, but no changes will be saved untill you hit the Save button.
                </p>
                <p>
                    There are at best three available models which contribute to the decision for the assigned difficulty level
                    (based on performed computations and below settings, not every model is always taken into consideration - 
                    you can ignore data with higher than desired errors or too small sample sizes).
                    If two or more of the models give the same difficulty level, it will be assigned.
                </p>

                <p>Difficulty interval options</p>
                <div class="form-check col-6">
                    <label class="form-check-label">
                        <input class="form-check-input" type="radio" name="int_split" id="int_split_equal_length" checked> Equal interval length 
                        <i class="fa fa-info" title="The difficulties are assigned uniformly. May produce insufficient questions with some difficulty levels if most questions have similar computed difficulties"></i>
                    </label>
                </div>
                <div class="form-check">
                    <label class="form-check-label col-6">
                        <input class="form-check-input" type="radio" name="int_split" id="int_split_natural_length" disabled> <s>Natural interval length</s> 
                        <i class="fa fa-info" title="The difficulties are assigned so that there is approximately the same number of questions in each difficulty level. If the exercise, for instance, contains mostly easy questions, the ones with a little higher computed difficulty will be given a higher assigned difficulty level."></i>
                    </label>
                </div>

                <div class="form-inline">
                <label class="form-check-label ">Ignore ICC as a source for difficulty level if standard error rate for difficulty is greater than
                    <input type="number" id="icc_max_std_err" value="3" min="0.1" step="0.1" class="form-control" />
                    </label>
                </div>
                <p>Is applied to both 1- and 2-parameter ICC models</p>
                <div class="form-inline">
                <label class="form-check-label">Ignore correct answers percentage as a source for difficulty level if number of answers is less than
                    <input type="number" id="corr_perc_min_answers" value="5" min="1" step="1" max="50" class="form-control" />
                    </label>
                </div>

                <div class="form-check">
                    <label class="form-check-label">
                        <input type="checkbox" id="no_diff_override" class="form-check-input" checked> Do not override existing assigned difficulties
                    </label>
                </div>

            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-primary" id="confirm-assign-diffs-btn">Assign difficulties</button>
                <button type="button" class="btn btn-light" data-dismiss="modal">Cancel</button>
            </div>
        </div>
    </div>
</div>
<div class="modal fade form" id="assignDifficultiesResults" tabindex="-1" role="dialog">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                <h5 class="modal-title">Automatic difficulty level assignment - results</h5>
            </div>
            <div class="modal-body" id="assign-diffs-results">
            </div>
            <div class="modal-footer">
                <button data-dismiss="modal" class="btn btn-light">Close</button>
            </div>
        </div>
    </div>
</div>
<div id="IccPlot" tabindex="-1" style="display: none">
    <button type="button" class="close" data-dismiss="modal" aria-label="Close" onClick="closePlot()">
        <span aria-hidden="true">&times;</span>
    </button>
    <h5 class="modal-title">Item Characteristic Curve</h5>
    <div class="modal-body" id="plot">
    </div>
</div>

<script>
    var difficultyLevels = [ 
        <% difficultyLevels.forEach(option => { %>
            { ordinal: <%- option.ordinal %>, name: '<%- option.name %>', rgb_color: '<%- option.rgb_color %>' },
        <% }); %>
        { ordinal: 0, name: 'None', rgb_color: '666'}];
</script>